import itertools
import argparse

fichier = "mdp.txt"

def create_file_perm_full_arg(word_list, word_number, exp_reg_avant, exp_reg_arriere):
    permutations = list(itertools.permutations(word_list, word_number))
    resultat = ["".join(perm) for perm in permutations]
    permutations_chaines = [exp_reg_avant + ''.join(i) + exp_reg_arriere for i in resultat]
    with open(fichier, "w", encoding="utf8") as f:
        for n in permutations_chaines:
            f.write(n + "\n")
    print("Votre fichier texte a été créé dans ce répertoire sous le nom de mdp.txt.")

def create_file_perm_ea(word_list, word_number, exp_reg_avant):
    permutations = list(itertools.permutations(word_list, word_number))
    resultat = ["".join(perm) for perm in permutations]
    permutations_chaines = [exp_reg_avant + ''.join(i) for i in resultat]
    with open(fichier, "w", encoding="utf8") as f:
        for n in permutations_chaines:
            f.write(n + "\n")
    print("Votre fichier texte a été créé dans ce répertoire sous le nom de mdp.txt.")

def create_file_perm_ed(word_list, word_number, exp_reg_arriere):
    permutations = list(itertools.permutations(word_list, word_number))
    resultat = ["".join(perm) for perm in permutations]
    permutations_chaines = [''.join(i) + exp_reg_arriere for i in resultat]
    with open(fichier, "w", encoding="utf8") as f:
        for n in permutations_chaines:
            f.write(n + "\n")
    print("Votre fichier texte a été créé dans ce répertoire sous le nom de mdp.txt.")

def create_file_perm_no_arg(word_list, word_number):
    permutations = list(itertools.permutations(word_list, word_number))
    resultat = ["".join(perm) for perm in permutations]
    permutations_chaines = [''.join(i) for i in resultat]
    with open(fichier, "w", encoding="utf8") as f:
        for n in permutations_chaines:
            f.write(n + "\n")
    print("Votre fichier texte a été créé dans ce répertoire sous le nom de mdp.txt.")

if __name__ == "__main__":
    parser = argparse.ArgumentParser(description="Casseur de mot de passe en Python")
    parser.add_argument("-l", dest="liste", help="Mots à permuter", nargs='+', required=True)
    parser.add_argument("-ed", dest="expression_reg_derriere", help="Choisissez une expression régulière à placer derrière chaque permutation.", required=False)
    parser.add_argument("-ea", dest="expression_reg_avant", help="Choisissez une expression régulière à placer devant chaque permutation.", required=False)
    parser.add_argument("-n", dest ="nombre", help="Choisissez le nombre de mots pour chaque permutation.", type=int, required=True)
    args = parser.parse_args()

    word_list = args.liste 

    if args.expression_reg_derriere and args.expression_reg_avant:
        create_file_perm_full_arg(word_list, args.nombre, args.expression_reg_avant, args.expression_reg_derriere)
    elif args.expression_reg_derriere and not args.expression_reg_avant:
        create_file_perm_ed(word_list, args.nombre, args.expression_reg_derriere)
    elif args.expression_reg_avant and not args.expression_reg_derriere:
        create_file_perm_ea(word_list, args.nombre, args.expression_reg_avant)
    else:
        create_file_perm_no_arg(word_list, args.nombre)
































